.\"	"@(#)bib.1	4.6	5/25/86";
.TH BIB 1 "May 25, 1986" "Univ of Arizona"
.UC 4
.SH NAME
bib, listrefs \- bibliographic formatter; list bibliographic reference items
.SH SYNOPSIS
\fBbib\fP [options] ...
.br
\fBlistrefs\fP [options] ...
.SH DESCRIPTION
\fIBib\fP is a preprocessor for \fInroff\fP or \fItroff\fP(1) that
formats citations and bibliographies.  The input files (standard input
default) are copied to the standard output, except for text between [. and .]
pairs, which are assumed to be keywords for searching a bibliographic database.
If a matching reference is found a citation is generated replacing the text.
References are collected, optionally sorted, and written out at a location
specified by the user.
Citation and reference formats are controlled by the \-t option.
.PP
Reference databases are created using the \fIinvert\fP utility.
.PP
The following options are available.
Note that standard format styles (see the \-t option) set options automatically.
Thus if a standard format style is used the user need not indicate any
further options for most documents.
.IP \-aa 8m
reduce author\*(CQs first names to abbreviations.
.IP \-ar\fInum\fP
reverse the first \fInum\fP author's names.
If a number is not given all authors names are reversed.
.IP \-ax
print authors last names in Caps-Small Caps style.  For example Budd becomes
B\s-2UDD\s+2.  This style is used by certain ACM publications.
.IP \-c\fIstr\fP
build citations according to the template \fIstr\fP.  See the reference
format designer\*(CQs guide for more information on templates.
.IP \-ea
reduce editors first names to abbreviations.
.IP \-ex
print editors last names in Caps-Small Caps style (see \-ax option).
.IP \-er\fInum\fP
reverse the first \fInum\fP editors names.  If a number is not given all
editors names are reversed.
.IP \-f
instead of collecting references, dump each
reference immediately following the line on which the citation is placed
(used for footnoted references).
.IP "\-i \fIfile\fP"
.ns
.IP  \-i\fIfile\fP
process the indicated file, such as a file of definitions.
(see technical report for a description of file format).
.IP \-h
replace citations to three or more adjacent reference items with
a hyphenated string (eg 2,3,4,5 becomes 2-5).
This option implies the \-o option.
.IP \-n\fIstr\fP
turn off indicated options.  \fIstr\fP must be composed of the letters afhosx.
.IP \-o
contiguous citations are ordered according the the reference list before
being printed (default).
.IP "\-p \fIfile\fP"
.ns
.IP  \-p\fIfile\fP
instead of searching the file INDEX,
search the indicated reference files before searching the system file.
\fIfiles\fP is a comma separated list of inverted indices, created using
the \fIinvert\fP utility.
.IP \-s\fIstr\fP
sort references according to the template \fIstr\fP.
.IP "\-t \fItype\fP"
.ns
.IP \-t\fItype\fP
use the standard macros and switch settings for the indicated style
to generate citations and references.
There are a number of standard styles provided.  In addition users
can generate their own style macros.  See the format designers guide for
details.
.PP
\fIListrefs\fP formats an entire reference database file.
Options to \fIlistrefs\fP
are the same as for \fIbib\fP.
.PP
\fIBib\fP was designed initially for use with the \-ms macros, and
uses a couple of the \-ms macros (.ip and .lp) in its macro definitions.
To use it with the \-me macros, prefix the file being sent to nroff/troff
with the following macro definitions:
.nf
.in +1.0i
\&.de IP
\&.ip \\$1 \\$2
\&..
\&.de LP
\&.lp
\&..
.fi
.in -1.0i
.PP
A file "bibmac.me" containing these macro
definitions may be found in /usr/new/lib/bmac.
.SH FILES
.ta 2i
INDEX	inverted index for reference database
.br
/usr/dict/papers/INDEX	default system index
.br
/usr/new/lib/bmac/bmac.*	formatting macro packages
.br
/usr/tmp/bibr*	scratch file for collecting references
.br
/usr/tmp/bibp*	output of pass one of bib
.SH SEE ALSO
\fIA UNIX Bibliographic Database Facility\fP, Timothy A. Budd and Gary M. Levin,
University of Arizona Technical Report 82-1, 1982.
(includes format designers guide).
.br
invert(1), troff(1)
