'\"
'\" Copyright 1992 Regents of the University of California
'\" Permission to use, copy, modify, and distribute this
'\" documentation for any purpose and without fee is hereby
'\" granted, provided that this notice appears in all copies.
'\" The University of California makes no representations about
'\" the suitability of this material for any purpose.  It is
'\" provided "as is" without express or implied warranty.
'\" 
'\" $Header: /user5/mottsmth/j/b/jbuild.man,v 1.8 92/05/07 09:02:14 mottsmth Exp $ SPRITE (Berkeley)
'\" 
.\" The definitions below are for supplemental macros used in Sprite
.\" manual entries.
.\"
.\" .HS name section [date [version]]
.\"	Replacement for .TH in other man pages.  See below for valid
.\"	section names.
.\"
.\" .AP type name in/out [indent]
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS [type [name]]
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .VS
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
'\"	# Heading for Sprite man pages
.de HS
.if '\\$2'cmds'       .TH \\$1 1 \\$3 \\$4
.if '\\$2'lib'        .TH \\$1 3 \\$3 \\$4
.if '\\$2'tcl'        .TH \\$1 3 \\$3 \\$4
.if '\\$2'tk'         .TH \\$1 3 \\$3 \\$4
.if t .wh -1.3i ^B
.nr ^l \\n(.l
.ad b
..
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ie !"\\$3"" \{\
.ta \\n()Au \\n()Bu
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp .5
..
.HS jbuild cmds
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
jbuild \- Reconstruct Jaquith disk index from tertiary storage
.SH SYNOPSIS
\fBjbuild [-root \fIrootPath\fR] [\fB-dev \fIdevice\fR]
[\fB-v\fR] [\fB-clobber\fR]  [\fB-noindex\fR]
[\fB-save\fR] [\fB-first \fIfirst-file\fR]  [\fB-last \fIlast-file\fR]
[\fB-before \fIdate\fR]  [\fB-after \fIdate\fR]
[\fB-matchpath \fIpath-expression\fR] 
[\fB-matchtbuf \fItbuf-expression\fR] 
.SH OPTIONS
.IP "\fB\-root \fIrootpath\fR" 14
Specify root of index tree.
.IP "\fB\-dev \fIdevice\fR" 14
The name of the reader device.
.IP "\fB\-v\fR" 14
Turn on verbose mode which prints status during operation.
.IP "\fB\-clobber\fR" 14
Overwrite the disk index with the tape index.
.IP "\fB\-noindex\fR" 14
Restore the thdr file from tape but don't rebuild the index.
This implies \fB-save\fR.
.IP "\fB\-save\fR" 14
Save the thdr file after index is restored.
.IP "\fB\-first \fIfirst-file\fR" 14
Number of first thdr file to restore. (0 == first file on tape).
.IP "\fB\-last \fIlast-file\fR" 14
Number of last thdr file to restore. (-1 == last file on tape).
.IP "\fB\-matchPath \fIpathname\fR" 14
Restore only files that match the path \fIpathname\fR according
to Unix globbing rules.
.IP "\fB\-matchtbuf \fItbuf-num\fR" 14
Restore only files that match the tbuf number \fItbuf-num\fR according
to Unix globbing rules.
.IP "\fB\-before \fIdate\fR" 14
Restore only entries archived before \fIdate\fR.
.IP "\fB\-after \fIdate\fR" 14
Restore only entries archived after \fIdate\fR.
.IP "\fB\-bufsize \fIbytesize\fR" 14
Read from tape in \fIbytesize\fR units.
.BE
.SH DESCRIPTION
.PP
\fBJbuild\fP is a system manager's utility for the Jaquith system.
It's purpose is to rebuild Jaquith's disk index from tape in the
event of disk crash.

.PP
Jbuild processes a single Jaquith tape by restoring a sequence of
index (thdr) file, parsing them, and rebuilding the tree structure on disk.
Several arguments control the details of the restoration:
The \fB-first\fR and \fR-last\fR arguments limit the range of
thdr files which are read from tape. The \fB-matchpath\fR argument 
restricts restoration to user file pathnames which match \fIpathname\fR.
The \fB-noindex\fR option inhibits the rebuilding of the disk index
entirely; only the raw thdr files are restored.

.PP
Jbuild is not network-aware since it is not for use by
clients. It assumes that it has direct access to the readers.

.PP
\fIdate\fR is of the form \fIDateSpec[:TimeSpec]\fR. \fITimeSpec\fR
is of the form [hh[:mm[:ss]]], and \fIDateSpec\fR is of the form
dd\(hymonth[\(hyyyyy]. Month is the first 3 letters of the month;
all others are numbers. The '/' character is a substitute
for '-' and '.' may be used instead of ':'.

.SH FILES
Jbuild creates a temporary work file in the Jaquith root called
rebuild.\fIpid\fR. The work file will be renamed \fIarch\fR/thdr.\fInumber\fR
after the thdr file has been restored to its archive,
or thdr.\fIpid\fR.\fIcount\fR, if the file appears to be bogus.

.SH BUGS
Jbuild can restore only one volume at a time; several invocations
may be necessary to restore an entire logical archive.

.SH "SEE ALSO"
jaquith jmgr jls jstat jput jget jctrl jcopy jclean

.SH KEYWORDS
jaquith archive

