.TH LESSKEY 1
.SH NAME
lesskey \- specify key bindings for less
.SH SYNOPSIS
.B "lesskey [-o output] [input]"
.SH DESCRIPTION
.I Lesskey
is used to specify a set of key bindings to be used by 
.I less.
The input file is a text file which describes the key bindings,
and the output file is a binary file which is used by 
.I less.
If no input file is specified, standard input is used.
If no output file is specified, $HOME/.less is used.
.PP
The input file consists of lines of the form:
.sp
	string <whitespace> action [extra-string] <newline>
.sp
Whitespace is any sequence of one or more spaces and/or tabs.
The "string" is the command key(s) which invoke the action.
The string may be a single command key, or a sequence of up to 15 keys.
The "action" is the name of the less action, from the list below.
The characters in the "string" may appear literally, or be
prefixed by a carat to indicate a control key.
A backslash may be used to cause the following character
to be taken literally.
Characters which must be preceded by backslash include
carat, space, tab and the backslash itself.
A backslash followed by one to three octal digits may be used to
specify a character by its octal value.
Blank lines and lines which start with a pound sign (#) are ignored.
.PP
An action may be followed by an extra string.
This string is parsed after the command is entered,
just as if it were entered on the command line.
This feature can be used in certain cases to extend
the functionality of a command.
For example, these entries would create a pair of commands
to turn on/off line numbers using
.I vi
syntax:
.sp
.nf
	:set\\ nu		toggle-option -N
	:set\\ nonu	toggle-option +N
.fi
.sp
See also the ":ta" command in the example below.

.SH EXAMPLE
The following input file describes the set of
default command keys used by less:
.sp
.nf
	r		forw-line 
	n		forw-line 
	e		forw-line 
	j		forw-line 
	^E		forw-line 
	^N		forw-line 
	k		back-line 
	y		back-line 
	^Y		back-line 
	^K		back-line 
	^P		back-line 
	J		forw-line-force 
	K		back-line-force 
	Y		back-line-force 
	d		forw-scroll 
	^D		forw-scroll 
	u		back-scroll 
	^U		back-scroll 
	'		back-scroll 
	\e40		forw-screen 
	f		forw-screen 
	^F		forw-screen 
	^V		forw-screen 
	b		back-screen 
	^B		back-screen 
	\e33v		back-screen 
	z		forw-window 
	w		back-window 
	F		forw-forever 
	R		repaint-flush 
	r		repaint 
	^R		repaint 
	^L		repaint 
	g		goto-line 
	<		goto-line 
	\e33<		goto-line 
	p		percent 
	%		percent 
	{		forw-bracket {}
	}		back-bracket {}
	(		forw-bracket ()
	)		back-bracket ()
	[		forw-bracket []
	]		back-bracket []
	\e33^F	forw-bracket 
	\e33^B	back-bracket 
	G		goto-end 
	\e33>		goto-end 
	>		goto-end 
	P		goto-end 
	=		status 
	^G		status 
	:f		status 
	/		forw-search 
	?		back-search 
	\e33/		forw-search *
	\e33?		back-search *
	n		repeat-search 
	\e33n		repeat-search-all 
	N		reverse-search 
	\e33N		reverse-search-all 
	m		set-mark 
	'		goto-mark 
	^X^X		goto-mark 
	E		examine 
	:e		examine 
	^X^V		examine 
	:n		next-file 
	:p		prev-file 
	:x		index-file 
	-		toggle-option 
	:t		toggle-option t
	s		toggle-option o
	_		display-option 
	|		pipe 
	v		visual 
	!		shell 
	+		firstcmd 
	H		help 
	h		help 
	V		version 
	q		quit 
	:q		quit 
	:Q		quit 
	ZZ		quit 
	\e33\e33	quit 
.fi
.sp
Commands specified by
.I lesskey
take precedence over the default commands.
A default command key may be disabled by including it in the
key file with the action "invalid".

.SH "SEE ALSO"
less(1)
