' Copyright 1989 Regents of the University of California
' Permission to use, copy, modify, and distribute this
' documentation for any purpose and without fee is hereby
' granted, provided that this notice appears in all copies.
' The University of California makes no representations about
' the suitability of this material for any purpose.  It is
' provided "as is" without express or implied warranty.
' 
' $Header: /a/newcmds/rcsbreak/RCS/rcsbreak.man,v 1.2 89/01/25 15:19:42 ouster Exp $ SPRITE (Berkeley)
' 
.so \*(]ltmac.sprite
.HS RCSBREAK cmds
.BS
.SH NAME
rcsbreak \- Break locks owned by other people on RCS files
.SH SYNOPSIS
.nf
\fBrcsbreak\fR \fIfile file ...\fR
.SH DESCRIPTION
.PP
\fBrcsbreak\fR is used to break RCS locks owned by others.  For each
\fIfile\fR specified on the command line, the file will be changed to
have been checked out by the person invoking \fBrcsbreak\fR.    The
file itself is not modified, so it will continue to be owned by the
original holder of the lock.  A typical use of \fBrcsbreak\fR is to
obtain the lock in order to check a file in on behalf of another user,
leaving the file writable:
.nf
	\fBrcsbreak\fR \fIfile\fR
	\fBci -l\fR \fIfile\fR
.fi
The \fBrcsdiff\fR program may be used to determine the changes already
made to the file, for the purpose of logging the change.
Alternatively, the \fBco\fP program may be used to check out the
previous version of the file, discarding any changes made by the
former holder of the lock.
.PP
\fBrcsbreak\fR sends mail to the former owner of each lock it breaks,
informing the owner that the lock has been broken.
.SH BUGS
.PP
The mail, generated by \fBrcs\fR, does not specify the reason why the
lock is broken.
.SH KEYWORDS
RCS, lock, break
.SH "SEE ALSO"
rcs, ci, co, rcsdiff
