.TH RCSDIFF 1 5/19/86 "Purdue University"
.SH NAME
rcsdiff \- compare RCS revisions
.SH SYNOPSIS
\fBrcsdiff\fR [ \fB\-biwt\fR ] [ \fB\-cefhn\fR ] [ \fB\-r\fIrev1\fR ] [ \fB\-r\fIrev2\fR ] file ...
.SH DESCRIPTION
.I Rcsdiff
runs \fIdiff\fR (1) to compare two revisions of each RCS file given.
A file name ending in ',v' is an RCS file name, otherwise a
working file name. \fIRcsdiff\fR derives the working file name from the RCS
file name and vice versa, as explained in \fIco\fR (1). Pairs consisting
of both an RCS and a working file name may also be specified.
.PP
All options except
.B \-r
have the same effect as described in
.IR diff (1).
.PP
If both \fIrev1\fR and \fIrev2\fR
are omitted, \fIrcsdiff\fR compares the latest revision on the trunk
with the contents of the corresponding working file. This is useful
for determining what you changed since the last checkin.
.PP
If \fIrev1\fR is given, but \fIrev2\fR is omitted,
\fIrcsdiff\fR compares revision \fIrev1\fR of the RCS file with
the contents of the corresponding working file.
.PP
If both \fIrev1\fR and \fIrev2\fR are given,
\fIrcsdiff\fR compares revisions \fIrev1\fR and \fIrev2\fR of the RCS file.
.PP
Both \fIrev1\fR and \fIrev2\fR may be given numerically or symbolically.
.SH EXAMPLES
.nf
The command

        rcsdiff  f.c

.fi
runs \fIdiff\fR on the latest trunk revision of RCS file f.c,v
and the contents of working file f.c.
.SH IDENTIFICATION
.de VL
\\$2
..
Author: Walter F. Tichy,
Purdue University, West Lafayette, IN, 47907.
.sp 0
Revision Number:
.VL $Revision: 1.2 $
; Release Date:
.VL $Date: 86/05/19 02:27:17 $
\&.
.sp 0
Copyright \(co 1982 by Walter F. Tichy.
.SH SEE ALSO
ci (1), co (1), diff (1), ident (1), rcs (1), rcsintro (1), rcsmerge (1), rlog (1), rcsfile (5).
.sp 0
Walter F. Tichy, "Design, Implementation, and Evaluation of a Revision Control
System," in \fIProceedings of the 6th International Conference on Software
Engineering\fR, IEEE, Tokyo, Sept. 1982.
.SH BUGS
