.\" Copyright (c) 1983 The Regents of the University of California.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms are permitted provided
.\" that: (1) source distributions retain this entire copyright notice and
.\" comment, and (2) distributions including binaries display the following
.\" acknowledgement:  ``This product includes software developed by the
.\" University of California, Berkeley and its contributors'' in the
.\" documentation or other materials provided with the distribution and in
.\" all advertising materials mentioning features or use of this software.
.\" Neither the name of the University nor the names of its contributors may
.\" be used to endorse or promote products derived from this software without
.\" specific prior written permission.
.\" THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
.\" WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
.\"
.\"	@(#)renice.8	6.4 (Berkeley) 6/24/90
.\"
.UC 7
.TH RENICE 8 "June 24, 1990"
.UC 4
.SH NAME
renice \- alter priority of running processes
.SH SYNOPSIS
.B renice
priority [ [
.B \-p
] pid ... ] [ [
.B \-g
] pgrp ... ] 
.SH DESCRIPTION
.I Renice
alters the 
scheduling priority of one or more running processes.
The
.I who
parameters are interpreted as process ID's, process group
ID's, or user names.
.IR Renice 'ing
a process group causes all processes in the process group
to have their scheduling priority altered.  
By default, the processes to be affected are specified by
their process ID's.  To force 
.I who
parameters to be interpreted as process group ID's, a
.B \-g 
may be specified.  Supplying
.B \-p
will reset 
.I who
interpretation to be (the default) process ID's.
.PP
Users other than the super-user may only alter the priority of
processes they own,
and can only monotonically increase their ``nice value''
within the range 0 to PRIO_MAX (20).
(This prevents overriding administrative fiats.)
The super-user
may alter the priority of any process
and set the priority to any value in the range PRIO_MIN (\-20)
to PRIO_MAX.
Useful priorities are:
20 (the affected processes will run only when nothing else
in the system wants to),
0 (the ``base'' scheduling priority),
anything negative (to make things go very fast).
.SH FILES
/etc/passwd	to map user names to user ID's
.SH SEE ALSO
getpriority(2), setpriority(2)
.SH BUGS
Non super-users can not increase scheduling priorities of their own processes,
even if they were the ones that decreased the priorities in the first place.
.SH SPRITE
Renice on Sprite must map Unix priorities in the range -20 to 20 into one
of the five Sprite priorities. The mapping is done as follows:
.br
-20 \(em -20 -> -20
.br
-19 \(em -10 -> -10
.br
 -9 \(em   9 ->  0
.br
 10 \(em  19 -> 10
.br
 20 \(em  20 -> 20
.br
For example, renice'ing a process to priority 9 will cause it
to run at the same priority as processes reniced to -9 through 9.  
