.\" Copyright (c) 1989 The Regents of the University of California.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to Berkeley by
.\" Rick Macklem at The University of Guelph.
.\"
.\" Redistribution and use in source and binary forms are permitted provided
.\" that: (1) source distributions retain this entire copyright notice and
.\" comment, and (2) distributions including binaries display the following
.\" acknowledgement:  ``This product includes software developed by the
.\" University of California, Berkeley and its contributors'' in the
.\" documentation or other materials provided with the distribution and in
.\" all advertising materials mentioning features or use of this software.
.\" Neither the name of the University nor the names of its contributors may
.\" be used to endorse or promote products derived from this software without
.\" specific prior written permission.
.\" THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
.\" WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
.\"
.\"	@(#)showmount.8	6.2 (Berkeley) 6/24/90
.\"
.TH SHOWMOUNT 8 "June 24, 1990"
.UC 4
.SH NAME
showmount \- show remote nfs mounts on host
.SH SYNOPSIS
.B showmount
[
.B \-ade
]
[
.B host
]
.SH DESCRIPTION
.I Showmount
shows status information about the NFS server on
.I host.
By default it prints the names of all hosts that have NFS file systems mounted
on the host. See "NFS: Network File System Protocol Specification, RFC1094,
Appendix A" for a detailed desciption of the protocol.
.TP
.B \-a
List all mount points in the form:
.RS
.RS
.I host:dirpath
.RE
.RE
.TP
.B \-d
List directory paths of mount points instead of hosts
.TP
.B \-e
Show the
.I host's
exports list
.SH "SEE ALSO"
mount(1), mountd(8)
.SH BUGS
The mount daemon running on the server only has an idea of the actual mounts,
since the NFS server is stateless. Showmount will only display the information
as accurately as the mount daemon reports it.
